/**
 * Helper for deterministic code generation / testing. Resets sym ID counter
 * (for {@link gensym}) to given ID (default: 0).
 *
 * @param id
 */
export declare const resetSymID: (id?: number) => number;
/**
 * Generates a new symbol name with optional given `prefix` (default: "_s"),
 * e.g. `_s123`. Uses base36 for internal counter to keep names short.
 *
 * @remarks
 * Also see {@link resetSymID}.
 *
 * @param prefix -
 */
export declare const gensym: (prefix?: string) => string;
//# sourceMappingURL=idgen.d.ts.map